Index: /trunk/src/org/expeditee/actions/Actions.java
===================================================================
--- /trunk/src/org/expeditee/actions/Actions.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Actions.java	(revision 1102)
@@ -19,6 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.GraphicsEnvironment;
-import java.io.Serializable;
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Method;
@@ -26,5 +24,4 @@
 import java.rmi.UnexpectedException;
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.Collection;
 import java.util.Comparator;
@@ -35,7 +32,7 @@
 
 import org.expeditee.agents.Agent;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
@@ -217,7 +214,7 @@
 	 *         actions.
 	 */
-	public static Collection<String> Init() {
-
-		Collection<String> warnings = new LinkedList<String>();
+	public static List<String> Init() {
+
+		List<String> warnings = new LinkedList<String>();
 		List<Class<?>> classes;
 
@@ -436,5 +433,5 @@
 		// 	loose changes
 		if (firstCanditate.getDeclaringClass().getName().equals(NAVIGATIONS_CLASS)) {
-			FrameIO.SaveFrame(DisplayIO.getCurrentFrame());
+			FrameIO.SaveFrame(DisplayController.getCurrentFrame());
 		}
 		final List<Method> canditates = new LinkedList<Method>();
@@ -825,5 +822,5 @@
 					+ nameWithCorrectCase + "'");
 		}
-		FrameGraphics.refresh(false);
+		DisplayController.requestRefresh(false);
 	}
 
@@ -1031,7 +1028,5 @@
 	private static void initFonts() {
 		if (_Fonts.size() == 0) {
-			String[] availableFonts = GraphicsEnvironment
-					.getLocalGraphicsEnvironment()
-					.getAvailableFontFamilyNames();
+			String[] availableFonts = EcosystemManager.getFontManager().getRegisteredFontFamilies();
 			for (String s : availableFonts) {
 				_Fonts.put(s.toLowerCase(), s);
Index: /trunk/src/org/expeditee/actions/Debug.java
===================================================================
--- /trunk/src/org/expeditee/actions/Debug.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Debug.java	(revision 1102)
@@ -21,5 +21,5 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Constraint;
 import org.expeditee.items.Item;
@@ -38,5 +38,5 @@
 	 */
 	public static void ShowConstraints() {
-		List<Item> items = DisplayIO.getCurrentFrame().getItems();
+		List<Item> items = DisplayController.getCurrentFrame().getItems();
 
 		for (Item i : items)
Index: /trunk/src/org/expeditee/actions/ExploratorySearchActions.java
===================================================================
--- /trunk/src/org/expeditee/actions/ExploratorySearchActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/ExploratorySearchActions.java	(revision 1102)
@@ -19,10 +19,11 @@
 package org.expeditee.actions;
 
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameKeyboardActions;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.items.Item;
@@ -59,8 +60,8 @@
 			}
 			
-			Text linkToBrowserSession = DisplayIO.getCurrentFrame().addText(FrameMouseActions.getX(), FrameMouseActions.getY(), " - Web Browser Session", null);
-			linkToBrowserSession.setParent(DisplayIO.getCurrentFrame());
-			FrameKeyboardActions.AddDate(linkToBrowserSession);
-			FrameMouseActions.pickup(linkToBrowserSession);
+			Text linkToBrowserSession = DisplayController.getCurrentFrame().addText(DisplayController.getMouseX(), DisplayController.getMouseY(), " - Web Browser Session", null);
+			linkToBrowserSession.setParent(DisplayController.getCurrentFrame());
+			Text.AddDate(linkToBrowserSession);
+			StandardGestureActions.pickup(linkToBrowserSession);
 			
 			// Create new frame
@@ -75,6 +76,6 @@
 			// Add web browser active overlay and @old
 			Text t = (Text) frame.addText(-150, 50, "@ao: 2", null, "overlayset2");
-			t.setAnchorRight(-100.0f);
-			t.setAnchorTop(50.0f);
+			t.setAnchorRight(-100);
+			t.setAnchorTop(50);
 			t = (Text) frame.addText(-150, 50, "@old", null);
 			t.setFamily("Roboto Condensed");
@@ -84,6 +85,6 @@
 			t.setJustification(Justification.right);
 			t.setLinkMark(false);
-			t.setAnchorLeft(9.0f);
-			t.setAnchorBottom(114.0f);
+			t.setAnchorLeft(9);
+			t.setAnchorBottom(114);
 			
 			Text wt;
@@ -101,6 +102,6 @@
 						+ ("--anchorLeft " + (lm + ExploratorySearchSettings.BROWSER_HORZ_OFFSET) + " --anchorRight " + rm + " --anchorTop " 
 						+ (ExploratorySearchSettings.BROWSER_VERT_OFFSET + tm) + " --anchorBottom " + bm + " ")
-						+ (Browser._theBrowser.getContentPane().getWidth() - ExploratorySearchSettings.BROWSER_HORZ_OFFSET - lm - rm) + " " 
-						+ (Browser._theBrowser.getContentPane().getHeight() - ExploratorySearchSettings.BROWSER_VERT_OFFSET - tm - bm) + " : " + url, null);
+						+ (EcosystemManager.getGraphicsManager().getWindowSize().getWidth() - ExploratorySearchSettings.BROWSER_HORZ_OFFSET - lm - rm) + " " 
+						+ (EcosystemManager.getGraphicsManager().getWindowSize().getHeight() - ExploratorySearchSettings.BROWSER_VERT_OFFSET - tm - bm) + " : " + url, null);
 			} else {
 				wt = frame.addText(ExploratorySearchSettings.BROWSER_HORZ_OFFSET + lm, ExploratorySearchSettings.BROWSER_VERT_OFFSET + tm,
@@ -122,8 +123,9 @@
 		// Replace any text item on cursor with link to a new mindmap
 		FreeItems.getInstance().clear();
-		Text text = DisplayIO.getCurrentFrame().addText(FrameMouseActions.getX(), FrameMouseActions.getY(), " - Mindmap Session", null);
-		text.setParent(DisplayIO.getCurrentFrame());
-		FrameKeyboardActions.AddDate(text);
-		FrameMouseActions.pickup(text);
+		Point cursorPos = DisplayController.getMousePosition();
+		Text text = DisplayController.getCurrentFrame().addText(cursorPos.getX(), cursorPos.getY(), " - Mindmap Session", null);
+		text.setParent(DisplayController.getCurrentFrame());
+		Text.AddDate(text);
+		StandardGestureActions.pickup(text);
 		Frame frame = FrameIO.CreateNewFrame(text);
 		text.setLink("" + frame.getNumber());
@@ -132,6 +134,6 @@
 		frame.removeAllItems(frame.getItems());
 		Text t = (Text) frame.addText(-150, 50, "@ao: 2", null, "overlayset3");
-		t.setAnchorLeft(-150.0f);
-		t.setAnchorTop(50.0f);
+		t.setAnchorLeft(-150);
+		t.setAnchorTop(50);
 		t = (Text) frame.addText(-150, 50, "@old", null);
 		t.setFamily("Roboto Condensed");
@@ -141,6 +143,6 @@
 		t.setJustification(Justification.right);
 		t.setLinkMark(false);
-		t.setAnchorLeft(9.0f);
-		t.setAnchorBottom(114.0f);
+		t.setAnchorLeft(9);
+		t.setAnchorBottom(114);
 		
 		FrameIO.SaveFrame(frame);
@@ -168,7 +170,8 @@
 			}
 			
-			Text linkToBrowserSession = DisplayIO.getCurrentFrame().addText(FrameMouseActions.getX(), FrameMouseActions.getY(), url, null);
-			linkToBrowserSession.setParent(DisplayIO.getCurrentFrame());
-			FrameMouseActions.pickup(linkToBrowserSession);
+			Point cursorPos = DisplayController.getMousePosition();
+			Text linkToBrowserSession = DisplayController.getCurrentFrame().addText(cursorPos.getX(), cursorPos.getY(), url, null);
+			linkToBrowserSession.setParent(DisplayController.getCurrentFrame());
+			StandardGestureActions.pickup(linkToBrowserSession);
 			
 			// Create new frame
@@ -183,6 +186,6 @@
 			// Add web browser active overlay and @old
 			Text t = (Text) frame.addText(-150, 50, "@ao: 2", null, "overlayset2");
-			t.setAnchorLeft(-150.0f);
-			t.setAnchorTop(50.0f);
+			t.setAnchorLeft(-150);
+			t.setAnchorTop(50);
 			t = (Text) frame.addText(-150, 50, "@old", null);
 			t.setFamily("Roboto Condensed");
@@ -192,6 +195,6 @@
 			t.setJustification(Justification.right);
 			t.setLinkMark(false);
-			t.setAnchorLeft(9.0f);
-			t.setAnchorBottom(114.0f);
+			t.setAnchorLeft(9);
+			t.setAnchorBottom(114);
 			
 			Text wt;
@@ -209,6 +212,6 @@
 						+ ("--anchorLeft " + (lm + ExploratorySearchSettings.BROWSER_HORZ_OFFSET) + " --anchorRight " + rm + " --anchorTop " 
 						+ (ExploratorySearchSettings.BROWSER_VERT_OFFSET + tm) + " --anchorBottom " + bm + " ")
-						+ (Browser._theBrowser.getContentPane().getWidth() - ExploratorySearchSettings.BROWSER_HORZ_OFFSET - lm - rm) + " " 
-						+ (Browser._theBrowser.getContentPane().getHeight() - ExploratorySearchSettings.BROWSER_VERT_OFFSET - tm - bm) + " : " + url, null);
+						+ (EcosystemManager.getGraphicsManager().getWindowSize().getWidth() - ExploratorySearchSettings.BROWSER_HORZ_OFFSET - lm - rm) + " " 
+						+ (EcosystemManager.getGraphicsManager().getWindowSize().getHeight() - ExploratorySearchSettings.BROWSER_VERT_OFFSET - tm - bm) + " : " + url, null);
 			} else {
 				wt = frame.addText(ExploratorySearchSettings.BROWSER_HORZ_OFFSET + lm, ExploratorySearchSettings.BROWSER_VERT_OFFSET + tm,
Index: /trunk/src/org/expeditee/actions/GreenstoneActions.java
===================================================================
--- /trunk/src/org/expeditee/actions/GreenstoneActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/GreenstoneActions.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
@@ -25,4 +24,5 @@
 
 import org.expeditee.agents.SearchGreenstone;
+import org.expeditee.core.Colour;
 import org.expeditee.greenstone.ResultDocument;
 import org.expeditee.gui.AttributeValuePair;
@@ -134,5 +134,5 @@
 			}
 		}
-		MessageBay.displayMessage("Feedback complete", null, Color.green
+		MessageBay.displayMessage("Feedback complete", null, Colour.GREEN
 				.darker(), true, null);
 	}
Index: /trunk/src/org/expeditee/actions/Help.java
===================================================================
--- /trunk/src/org/expeditee/actions/Help.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Help.java	(revision 1102)
@@ -25,7 +25,7 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -77,7 +77,7 @@
 		});
 
-		Frame current = DisplayIO.getCurrentFrame();
-		float x = FrameMouseActions.MouseX;
-		float y = FrameMouseActions.MouseY;
+		Frame current = DisplayController.getCurrentFrame();
+		float x = DisplayController.getFloatMouseX();
+		float y = DisplayController.getFloatMouseY();
 
 		// Do case sensitive comparison
Index: /trunk/src/org/expeditee/actions/IDE.java
===================================================================
--- /trunk/src/org/expeditee/actions/IDE.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/IDE.java	(revision 1102)
@@ -19,11 +19,9 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
-import java.io.BufferedReader;
 import java.io.File;
-import java.io.InputStreamReader;
 
 import org.expeditee.agents.WriteTree;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
@@ -37,5 +35,5 @@
 		int exitVal = 0; // default's to status OK
 		
-		Frame source = DisplayIO.getCurrentFrame();
+		Frame source = DisplayController.getCurrentFrame();
 		String title = source.getTitleItem().getText();
 		String[] tokens = title.split("\\s+");
@@ -72,5 +70,5 @@
 				}
 				else {
-					MessageBay.displayMessage("Compiled " + fileName, Color.darkGray);
+					MessageBay.displayMessage("Compiled " + fileName, Colour.DARK_GREY);
 				}
 			} catch (Exception e) {
@@ -101,5 +99,5 @@
 	
 	public static void RunClass() {
-		Frame source = DisplayIO.getCurrentFrame();
+		Frame source = DisplayController.getCurrentFrame();
 		String className = getClassName(source);
 		try {
Index: /trunk/src/org/expeditee/actions/Javascript.java
===================================================================
--- /trunk/src/org/expeditee/actions/Javascript.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Javascript.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
 import java.util.LinkedList;
 import java.util.List;
@@ -26,7 +25,7 @@
 import org.expeditee.agents.Agent;
 import org.expeditee.agents.DefaultAgent;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.MessageBay;
@@ -75,5 +74,5 @@
 	private static int _stepPause = -1;
 
-	private static Color _stepColor;
+	private static Colour _stepColor;
 
 	private static boolean _nextStatement;
@@ -93,5 +92,5 @@
 	//Have changed parameters, so it takes an Item, not just a Text item.
 	private static void RunJavascriptFrame(Frame frame, Item current,
-			boolean acceptKeyboardInput, boolean step, int pause, Color color) {
+			boolean acceptKeyboardInput, boolean step, int pause, Colour color) {
 		try {
 			if (current != null) {
@@ -101,5 +100,5 @@
 				 */
 				// DisplayIO.addToBack(current.getParent());
-				DisplayIO.addToBack(DisplayIO.getCurrentFrame());
+				DisplayController.addToBack(DisplayController.getCurrentFrame());
 			} else {
 				/* TODO we should not have to pass an item just to run a frame! */
@@ -108,7 +107,7 @@
 			}
 
-			_stepColor = color == null ? Color.green : color;
-			_stepColor = new Color(_stepColor.getRed(), _stepColor.getGreen(),
-					_stepColor.getBlue(), 50);
+			_stepColor = color == null ? Colour.GREEN : color;
+			_stepColor = new Colour(_stepColor.getRed(), _stepColor.getGreen(),
+					_stepColor.getBlue(), Colour.FromComponent255(50));
 			_stepPause = pause;
 			_step = step;
@@ -168,5 +167,5 @@
 		FrameUtils.DisplayFrame(item.getParent().getName(), true, true);
 		item.setHighlightMode(HighlightMode.Normal);
-		item.setHighlightColor(Color.CYAN);
+		item.setHighlightColor(Colour.CYAN);
 		FrameIO.SaveFrame(item.getParent());
 	}
@@ -192,8 +191,8 @@
 
 		if (_step) {
-			if (child != DisplayIO.getCurrentFrame()) {
-				DisplayIO.setCurrentFrame(child, true);
-			}
-			DisplayIO.addToBack(child);
+			if (child != DisplayController.getCurrentFrame()) {
+				DisplayController.setCurrentFrame(child, true);
+			}
+			DisplayController.addToBack(child);
 		}
 
@@ -216,5 +215,5 @@
 			AgentStats.ItemExecuted();
 			try {
-				Color oldColor = item.getBackgroundColor();
+				Colour oldColor = item.getBackgroundColor();
 				if (_step) {
 					pause(item);
@@ -226,4 +225,5 @@
 					} else {
 						item.setHighlightMode(Item.HighlightMode.None);
+						item.setHighlightColorToDefault();
 					}
 				}
@@ -233,5 +233,5 @@
 							&& lastItemStatus != Status.FalseIf) {
 						if (_step) {
-							DisplayIO.removeFromBack();
+							DisplayController.removeFromBack();
 						}
 						return lastItemStatus;
@@ -257,7 +257,7 @@
 
 		if (_step) {
-			DisplayIO.removeFromBack();
-			if (DisplayIO.getCurrentFrame() != current.getParent())
-				DisplayIO.setCurrentFrame(current.getParent(), true);
+			DisplayController.removeFromBack();
+			if (DisplayController.getCurrentFrame() != current.getParent())
+				DisplayController.setCurrentFrame(current.getParent(), true);
 		}
 
@@ -276,15 +276,16 @@
 			return;
 
-		Color oldColor = item.getBackgroundColor();
+		Colour oldColor = item.getBackgroundColor();
 		item.setBackgroundColor(_stepColor);
 		item.setHighlightMode(Item.HighlightMode.None);
+		item.setHighlightColorToDefault();
 
 		// Make sure we are on the frame with this item
 		Frame parent = item.getParentOrCurrentFrame();
-		if (!parent.equals(DisplayIO.getCurrentFrame())) {
-			DisplayIO.setCurrentFrame(parent, true);
-		}
-
-		FrameGraphics.Repaint();
+		if (!parent.equals(DisplayController.getCurrentFrame())) {
+			DisplayController.setCurrentFrame(parent, true);
+		}
+
+		DisplayController.requestRefresh(true);
 
 		int timeRemaining;
@@ -297,5 +298,5 @@
 			if (_stop) {
 				item.setBackgroundColor(oldColor);
-				item.setHighlightMode(HighlightMode.Normal, _stepColor);
+				item.setHighlightModeAndColour(HighlightMode.Normal, _stepColor);
 				throw new Exception("Program terminated");
 			}
@@ -388,5 +389,5 @@
 		_programsRunning++;
 		AgentStats.reset();
-		MessageBay.displayMessage("Running Javascript Program ...", Color.BLUE);
+		MessageBay.displayMessage("Running Javascript Program ...", Colour.BLUE);
 	}
 
Index: /trunk/src/org/expeditee/actions/Javascript2.java
===================================================================
--- /trunk/src/org/expeditee/actions/Javascript2.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Javascript2.java	(revision 1102)
@@ -19,25 +19,9 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
-import java.util.Collection;
-import java.util.LinkedList;
-import java.util.List;
-
-import javax.script.Bindings;
 import javax.script.Invocable;
-import javax.script.ScriptContext;
-import javax.script.ScriptEngine;
-import javax.script.ScriptEngineManager;
-import javax.script.ScriptException;
-import javax.script.SimpleScriptContext;
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.MessageBay;
-import org.expeditee.io.flowlayout.XGroupItem;
 import org.expeditee.items.Item;
-import org.expeditee.items.ItemUtils;
-import org.expeditee.items.Text;
 
 /**
Index: /trunk/src/org/expeditee/actions/JfxBrowserActions.java
===================================================================
--- /trunk/src/org/expeditee/actions/JfxBrowserActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/JfxBrowserActions.java	(revision 1102)
@@ -22,17 +22,13 @@
 import java.io.InputStreamReader;
 import java.net.HttpURLConnection;
-import java.net.MalformedURLException;
-import java.net.URI;
-import java.net.URISyntaxException;
 import java.net.URL;
 import java.net.URLEncoder;
 import java.util.ArrayList;
 
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.FreeItems;
@@ -42,7 +38,6 @@
 import org.expeditee.items.Picture;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.JfxBrowser;
-import org.expeditee.settings.exploratorysearch.ExploratorySearchSettings;
 import org.expeditee.settings.network.NetworkSettings;
 import org.json.simple.JSONObject;
@@ -83,11 +78,11 @@
 		FreeItems.getInstance().clear();					// remove url text from cursor
 		
-		wt.setParent(DisplayIO.getCurrentFrame());			// set parent of text source for InteractiveWidget.createWidget()
-		wt.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
+		wt.setParent(DisplayController.getCurrentFrame());			// set parent of text source for InteractiveWidget.createWidget()
+		wt.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());
 		
 		// create widget from text item
-		JfxBrowser browser = (JfxBrowser) InteractiveWidget.createWidget(wt);
+		JfxBrowser browser = (JfxBrowser) Widget.createWidget(wt);
 			
-		FrameMouseActions.pickup(browser.getItems());		// attach browser widget to mouse
+		StandardGestureActions.pickup(browser.getItems());		// attach browser widget to mouse
 	}
 	
@@ -109,8 +104,8 @@
 		// If no text with url is passed to action create a new text item with http://www.waikato.ac.nz for a default url
 		if(!FreeItems.textOnlyAttachedToCursor()) {
-			text = DisplayIO.getCurrentFrame().addText(FrameMouseActions.getX(), FrameMouseActions.getY(), 
+			text = DisplayController.getCurrentFrame().addText(DisplayController.getMouseX(), DisplayController.getMouseY(), 
 					NetworkSettings.HomePage.get(), null);
-			text.setParent(DisplayIO.getCurrentFrame());	// set parent of text source for InteractiveWidget.createWidget()
-			FrameMouseActions.pickup(text);					// Attach new text link to cursor
+			text.setParent(DisplayController.getCurrentFrame());	// set parent of text source for InteractiveWidget.createWidget()
+			StandardGestureActions.pickup(text);					// Attach new text link to cursor
 		}
 		
@@ -123,8 +118,8 @@
 		Text wt = frame.addText(0, 0, "@iw: org.expeditee.items.widgets.JfxBrowser " 
 				+ ("--anchorLeft 0 --anchorRight 0 --anchorTop 0 --anchorBottom 0 ")
-				+ Browser._theBrowser.getContentPane().getWidth() +  " " + Browser._theBrowser.getContentPane().getHeight() 
+				+ EcosystemManager.getGraphicsManager().getWindowSize().getWidth() +  " " + EcosystemManager.getGraphicsManager().getWindowSize().getHeight() 
 				+ " : " + text.getText(), null);
 		
-		InteractiveWidget.createWidget(wt);
+		Widget.createWidget(wt);
 		
 		FrameIO.SaveFrame(frame);							// save frame to disk
@@ -179,6 +174,6 @@
 
 		// Create widget via text annotation
-		frame.addText(10, 10, "@iw: org.expeditee.items.widgets.JfxBrowser " + (int) (FrameGraphics.getMaxFrameSize().getWidth() * 0.9) + " "
-				+ (int) (FrameGraphics.getMaxFrameSize().getHeight() * 0.9) + " : " + url, null);
+		frame.addText(10, 10, "@iw: org.expeditee.items.widgets.JfxBrowser " + (int) (DisplayController.getFramePaintArea().getWidth() * 0.9) + " "
+				+ (int) (DisplayController.getFramePaintArea().getHeight() * 0.9) + " : " + url, null);
 
 		FrameIO.SaveFrame(frame);
@@ -294,5 +289,5 @@
 
 					if (!picSource.equals("")) {
-						pic = WebParser.getImageFromUrl(picSource, null, DisplayIO.getCurrentFrame(), 0, 0, 50, null, null,
+						pic = WebParser.getImageFromUrl(picSource, null, DisplayController.getCurrentFrame(), 0, 0, 50, null, null,
 								null, null, null, 0, 0);
 						items.add(pic);
@@ -300,5 +295,5 @@
 					}
 
-					titleItem.setPosition(FrameMouseActions.getPosition());
+					titleItem.setPosition(DisplayController.getMousePosition());
 					mainTextItem.setPosition(titleItem.getX(), titleItem.getY() + titleItem.getBoundsHeight());
 					sourceItem.setPosition(mainTextItem.getX(), mainTextItem.getY() + mainTextItem.getBoundsHeight());
@@ -313,5 +308,5 @@
 					items.add(sourceItem);
 					items.add(ddgLink);
-					FrameMouseActions.pickup(items);
+					StandardGestureActions.pickup(items);
 				} catch (IOException e) {
 					MessageBay.displayMessage("Problem loading results");
Index: /trunk/src/org/expeditee/actions/Mail.java
===================================================================
--- /trunk/src/org/expeditee/actions/Mail.java	(revision 1101)
+++ /trunk/src/org/expeditee/actions/Mail.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.actions;
 
-import java.awt.Color;
 import java.util.Collection;
 
@@ -25,9 +24,10 @@
 
 import org.expeditee.agents.mail.MailSession;
+import org.expeditee.core.Colour;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.gui.AttributeValuePair;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameKeyboardActions;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
@@ -116,5 +116,5 @@
 	public static Text getMailByID(int messageNo) {
 		Text mailItem = MailSession.getInstance().getMail(
-				DisplayIO.getCurrentFrame(), FrameMouseActions.getPosition(),
+				DisplayController.getCurrentFrame(), DisplayController.getMousePosition(),
 				messageNo - 1);
 		// MessageBay.displayMessage(mailItems.size() + " messages read",
@@ -139,6 +139,6 @@
 			int noOfMessages) {
 		Collection<Text> mailItems = MailSession.getInstance().getMail(flag,
-				isPresent, DisplayIO.getCurrentFrame(),
-				FrameMouseActions.getPosition(), noOfMessages);
+				isPresent, DisplayController.getCurrentFrame(),
+				DisplayController.getMousePosition(), noOfMessages);
 		// MessageBay.displayMessage(mailItems.size() + " messages read",
 		// Color.green);
@@ -187,7 +187,7 @@
 
 		reply.setActions(null);
-		FrameMouseActions.tdfc(reply);
-
-		Frame replyFrame = DisplayIO.getCurrentFrame();
+		StandardGestureActions.tdfc(reply);
+
+		Frame replyFrame = DisplayController.getCurrentFrame();
 		String titleText = frame.getTitle();
 		// Add Re on the end if it is not already there
@@ -197,18 +197,17 @@
 		}
 		replyFrame.setTitle(titleText);
-		FrameKeyboardActions.Drop(null, false);
+		StandardGestureActions.Drop(null, false);
 
 		// Add a link to the original message
 		Text original = replyFrame.createNewText("@original");
-		original.setPosition(FrameMouseActions.getPosition());
+		original.setPosition(DisplayController.getMousePosition());
 		original.setLink(frame.getName());
-		FrameKeyboardActions.Drop(original, false);
+		StandardGestureActions.Drop(original, false);
 
 		Text to = replyFrame.createNewText("@to: " + fromAddress);
-		to.setPosition(FrameMouseActions.getPosition());
+		to.setPosition(DisplayController.getMousePosition());
 		to.addAction("MailTree");
-		FrameKeyboardActions.Drop(to, false);
-		DisplayIO.setCursorPosition(FrameMouseActions.MouseX,
-				FrameMouseActions.MouseY + 15);
+		StandardGestureActions.Drop(to, false);
+		DisplayController.setCursorPosition(DisplayController.getMouseX(), DisplayController.getMouseY() + 15);
 	}
 
@@ -216,5 +215,5 @@
 		if (FrameShare.getInstance().sendMessage(message, peerName)) {
 			MessageBay.displayMessage("Sent message to " + peerName,
-					Color.green.darker());
+					Colour.GREEN.darker());
 		} else {
 			MessageBay.errorMessage("Could not find " + peerName);
